#include <stdio.h>
#include <math.h>

// pingutused nulliga algavate arvude valjastamiseks!

const char *fmt[12] = {"%01d","%02d","%03d", "%04d","%05d","%06d","%07d","%08d","%09d"};
int parim = -99999;
int p_pikkus;
int p_kaigud[12];
int p_pk[12];
int p_trahv;
int kaigud[12];
int pk[12];

int kivid[10] = {0,0,0,0,0,  0,0,0,0,0};
int trahv;



int onalgarv(int p) {
	int i;
	if ((p == 1) || (p == 0)) 
		return 0;
	for (i = 2; i <= sqrt(p); i++) 
		if (p % i == 0)
			return 0;
	return 1;
}

/* 
   lihtne rekursiivne variantide labivaatus.

   pikkus - otsingutee pikkus
   punktid - seni kogutud punktid (eelmise kaigu lisame jargmise valjakutse alguses)
   laual - laual olevate kivide hind.
   vasak,parem - laual olev arv int'ina, molemat pidi.
   mask - arvu pikkus  
   
*/
   
void otsi(int pikkus, int punktid,  int laual, int vasak, int parem, int mask) {
	int i;
	if (pikkus > 0) {
		kaigud[pikkus-1] = vasak;
		
		if (onalgarv(vasak)) {
			punktid += laual;
		}

		if (onalgarv(parem)) {
			punktid += laual;
		}
		pk[pikkus - 1] = punktid;
		 
	}
	
	if ((mask == 0) || onalgarv(vasak) || onalgarv(parem)) {
		if (parim < (punktid - trahv + laual)) {
			parim = punktid - trahv + laual;
			p_pikkus = pikkus;
			for (i=0;i<pikkus;i++) {
				p_kaigud[i] = kaigud[i];
				p_pk[i] = pk[i];
			}
			p_trahv = laual - trahv;
		}
	}

	for (i=0;i<=9;i++) {
		if (kivid[i] > 0)  {
			kivid[i]--;	
		
			if (mask == 0)	{
				otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), i, i, 1);
			} else {
				otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), mask * 10 * i + vasak,  parem * 10 + i, mask * 10);
				if (vasak != parem)  // kui arv on molematpidi sama, siis pole vaja sama numbrit molemasse otsa lisada
				otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), vasak * 10 + i, mask * 10 * i + parem, mask * 10);

			}
				
			kivid[i]++;	
		}
		
	}
}

int main() {
	FILE *sisf;
	FILE *valf;
	int n,i,k;
	sisf = fopen("algesis.txt","r");
	valf = fopen("algeval.txt","w");
	fscanf(sisf,"%d",&n);
	for (i = 0; i < n; i++) {
		fscanf(sisf,"%d",&k);
		kivid[k]++;	
		trahv += ((k == 0) ? 10 : k);
	}

	otsi(0,0,0,0,0,0);

	fprintf(valf,"%d %d\n",p_pikkus, parim);
	for (i=0;i<p_pikkus;i++) {
		fprintf(valf,fmt[i],p_kaigud[i]);
		fprintf(valf," %d\n",p_pk[i]);
	}
	fprintf(valf,"%d\n",p_trahv);
	fclose(sisf);
	fclose(valf);
	return 0;
}
