#include <map>

#include <cstdio>
#include <cmath>


/* 

lahendus erineb alglah1.c lahenudsest jargmiste omaduste poolest:

	- "vaikeste" arvude algarvulisuse kontrolli kiirendamiseks kasutame Eratosthenese soela.

        - "suurte" algarvude puhul hoime tehtud kontrolli tulemusi "acache" map'is

        -  kasutame variantide labivaatuse pugamist - iga laual oleva voimaliku seisu jaoks peame meeles parimat
           punktisummat mis selleks hetkeks voib olla kogutud ja loobume variantide edasisest labivaatusest,
           kui summa on samahea voi halvem vorreldes senise parima tulemusega.


*/
#define MS 9000000

std::map<int,int> acache;

std::map<int,int> pyga;

char soel[MS];

void alg() {
	int i,j;
	for (i=0;i<MS;i++) 
		soel[i] = 1;
	soel[0] = 0;
	soel[1] = 0;
	for (i=0;i<MS;i++) {
		if (soel[i] == 1) 
			for (j=2 * i; j < MS ; j += i)
				soel[j] = 0;
		
	}
}

const char *fmt[12] = {"%01d","%02d","%03d", "%04d","%05d","%06d","%07d","%08d","%09d"};
int parim = -99999;
int p_pikkus;
int p_kaigud[12];
int p_pk[12];
int p_trahv;
int kaigud[12];
int pk[12];

int kivid[10] = {0,0,0,0,0,  0,0,0,0,0};
int trahv;

int onalgarv(int p) {
	int i;
	if (p < MS) 	
		return soel[p];

	if (acache.find(p) == acache.end()) {
		for (i = 2; i <= sqrt(p); i++) {
			if ((i < MS ) && (soel[i] == 0))
				continue;
			if (p % i == 0) {
				acache[p] = 0;
				return 0;
			}
		}
		acache[p] = 1;
	} 
	return acache[p];
}

/* pikkus - otsingutee pikkus
 	

*/
   
void otsi(int pikkus, int punktid,  int laual, int vasak, int parem, int mask) {
	int i;
	if (pikkus > 0) {
		kaigud[pikkus-1] = vasak;
		
		if (onalgarv(vasak)) {
			punktid += laual;
		}

		if (onalgarv(parem)) {
			punktid += laual;
		}
		pk[pikkus - 1] = punktid;
		 
	}
	
	if ((mask == 0) || onalgarv(vasak) || onalgarv(parem)) {
		if (parim < (punktid - trahv + laual)) {
			parim = punktid - trahv + laual;
			p_pikkus = pikkus;
			for (i=0;i<pikkus;i++) {
				p_kaigud[i] = kaigud[i];
				p_pk[i] = pk[i];
			}
			p_trahv = laual - trahv;
		}
	}

	if (pyga.find( (vasak > parem ) ? vasak : parem) == pyga.end()) {
		pyga[(vasak > parem ) ? vasak : parem] = punktid;
	} else {
		if (pyga[(vasak > parem ) ? vasak : parem] >= punktid)
			return;
	}

	for (i=9;i>=0;i--) {
		if (kivid[i] > 0)  {
			kivid[i]--;	
		
			if (mask == 0)	{
				otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), i, i, 1);
			} else {
				otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), mask * 10 * i + vasak,  parem * 10 + i, mask * 10);
				if (vasak != parem) 
				otsi(pikkus + 1, punktid, laual + ((i==0)? 10 : i), vasak * 10 + i, mask * 10 * i + parem, mask * 10);

			}
				
			kivid[i]++;	
		}
		
	}
}

int main() {
	FILE *sisf;
	FILE *valf;
	int n,i,k;
	sisf = fopen("algesis.txt","r");
	valf = fopen("algeval.txt","w");
	fscanf(sisf,"%d",&n);
	for (i = 0; i < n; i++) {
		fscanf(sisf,"%d",&k);
		kivid[k]++;	
		trahv += ((k == 0) ? 10 : k);
	}

	alg();
	otsi(0,0,0,0,0,0);

	fprintf(valf,"%d %d\n",p_pikkus, parim);
	for (i=0;i<p_pikkus;i++) {
		fprintf(valf,fmt[i],p_kaigud[i]);
		fprintf(valf," %d\n",p_pk[i]);
	}
	fprintf(valf,"%d\n",p_trahv);
	fclose(sisf);
	fclose(valf);
}
