# coding: utf-8

# 2016-11-19 programmeerimisvõistlus
# Ülesanne: ALGARVU-SCRABBLE (edasijõudnute variant)
# Autor: Ahto Truu

# Algarvulisuse kontrolli kiirendamiseks vaatleme tegureid
# ainult kandidaadi ruutjuureni

# leiab kivijada a summa
def summa(a):
	n = 0
	for x in a:
		if x == '0':
			n = n + 10
		else:
			n = n + int(x)
	return n

# kontrollib, kas kivijada a on algarv
def algarv(a):
	# kõigepealt leiame jada esitatava arvu väärtuse
	n = int(a)
	# nüüd kontrollime, kas see on algarv
	if n < 2:
		return False
	i = 2
	while i * i <= n:
		if n % i == 0:
			return False
		i = i + 1
	return True

# globaalsed muutujad parima leitud lahenduse hoidmiseks
# parim_plaan on käigujada, kus iga käik on paar
# (kivi, 0/1 == vasakule/paremale)
parim_summa = -100
parim_plaan = []

# proovib panna kivid lauale jadas p näidatud järjekorras
# iga kivi võib panna seisule juurde kas vasakule või paremale
# a on jooksev seis laual, b senine käigujada,
# s seni kogunenud skoor, t trahviks minevad kivid
def otsi(p, a, b, s, t):
	global parim_summa, parim_plaan
	if len(a) == len(p):
		# kõik kivid on pandud, teeme lõpuarvestuse
		s = s - summa(t)
		if parim_summa < s:
			parim_plaan = b[ : len(b) - len(t)]
			parim_summa = s
	else:
		# järjekorras järgmine kivi
		x = p[len(a)]
		# proovime panna järgmise kivi vasakule
		kaik(p, x + a, b + [(x, 0)], s, t + x)
		# proovime panna järgmise kivi paremale
		kaik(p, a + x, b + [(x, 1)], s, t + x)

# arvutab viimase tehtud käigu mõju skoorile ja trahvile
def kaik(p, a, b, s, t):
	if algarv(a):
		s = s + summa(a)
		t = ''
	if algarv(a[::-1]):
		s = s + summa(a)
		t = ''
	# otsime järgmist käiku
	otsi(p, a, b, s, t)

# genereerib kivide jada a kõik järjekorrad (permutatsioonid)
# a on olemasolevate kivide hulk, v nende olekud (laual/käes)
# p seni kogunenud osaline ümberjärjestus
def perm(a, v, p):
	if len(p) == len(a):
		# ümberjärjestus valmis
		otsi(p, '', [], 0, '')
	else:
		# proovime järgmiseks kiviks kõiki veel käes olevaid
		for (i, x) in enumerate(a):
			if v[i]:
				v[i] = False
				perm(a, v, p + x)
				v[i] = True

#
# põhiprogrammi algus
#

sis = open('algesis.txt', 'rt')
val = open('algeval.txt', 'wt')

n = int(sis.readline().strip())
a = ''.join(sis.readline().strip().split())
v = [True] * len(a)

perm(a, v, '')

val.write('{0} {1}\n'.format(len(parim_plaan), parim_summa))
s = 0
a = ''
for (x, k) in parim_plaan:
	if k == 0:
		a = x + a
	if k == 1:
		a = a + x
	if algarv(a):
		s = s + summa(a)
	if algarv(a[::-1]):
		s = s + summa(a)
	val.write('{0} {1}\n'.format(a, s))
val.write('{0}\n'.format(parim_summa - s))
