# coding: utf-8

# 2016-11-19 programmeerimisvõistlus
# Ülesanne: ALGARVU-SCRABBLE (edasijõudnute variant)
# Autor: Ahto Truu

# Väldib sama väärtusega kivide omavaheliste ümberjärjestuste
# vaatlemist erinevate variantidena

import bisect # kahendotsing

# leiab kivijada a summa
def summa(a):
	n = 0
	for x in a:
		if x == '0':
			n = n + 10
		else:
			n = n + int(x)
	return n

# arvutab valmis algarvude tabeli
algarvud = []
def leia_algarvud(n):
	algarvud.append(2)
	for k in range(3, n, 2):
		for i in algarvud:
			if k % i == 0:
				break;
			if k < i * i:
				algarvud.append(k)
				break

# kontrollib, kas kivijada a on algarv
arvud = {}
def algarv(a):
	# kõigepealt leiame jada esitatava arvu väärtuse
	n = int(a)
	# nüüd kontrollime, kas see on algarv
	i = bisect.bisect_left(algarvud, n)
	if i < len(algarvud):
		# piisavalt väikese arvu korral kontrollime, kas ta on tabelis
		return algarvud[i] == n
	# suure arvu korral vaatame, kas me oleme seda juba uurinud
	if not n in arvud:
		# mälus tulemust ei ole, arvutame; proovime jagada kõigi algarvudega
		# see töötab õigesti ainult piisavalt suure tabeli korral
		for i in algarvud:
			if n % i == 0:
				arvud[n] = False
				break
			if n < i * i:
				arvud[n] = True
				break
	return arvud[n]

# globaalsed muutujad parima leitud lahenduse hoidmiseks
# parim_plaan on käigujada, kus iga käik on paar
# (kivi, 0/1 == vasakule/paremale)
parim_summa = -100
parim_plaan = []

# proovib panna kivid lauale jadas p näidatud järjekorras
# iga kivi võib panna seisule juurde kas vasakule või paremale
# a on jooksev seis laual, b senine käigujada,
# s seni kogunenud skoor, t trahviks minevad kivid
def otsi(p, a, b, s, t):
	global parim_summa, parim_plaan
	if len(a) == len(p):
		# kõik kivid on pandud, teeme lõpuarvestuse
		s = s - summa(t)
		if parim_summa < s:
			parim_plaan = b[ : len(b) - len(t)]
			parim_summa = s
	else:
		# järjekorras järgmine kivi
		x = p[len(a)]
		# proovime panna järgmise kivi vasakule
		kaik(p, x + a, b + [(x, 0)], s, t + x)
		# proovime panna järgmise kivi paremale
		kaik(p, a + x, b + [(x, 1)], s, t + x)

# arvutab viimase tehtud käigu mõju skoorile ja trahvile
def kaik(p, a, b, s, t):
	if algarv(a):
		s = s + summa(a)
		t = ''
	if algarv(a[::-1]):
		s = s + summa(a)
		t = ''
	# otsime järgmist käiku
	otsi(p, a, b, s, t)

# genereerib kivide jada a kõik permutatsioonid
def perm(a):
	a = list(a)
	a.sort()
	a = ''.join(a)
	while True:
		# ümberjärjestus valmis
		otsi(a, '', [], 0, '')
		# leiame järgmise
		# vt https://en.wikipedia.org/wiki/Permutation#Generation_in_lexicographic_order
		k = n - 2
		while k >= 0 and a[k] >= a[k + 1]:
			k = k - 1
		if k < 0:
			# oli viimane permutatsiooni
			break
		i = n - 1
		while a[k] >= a[i]:
			i = i - 1
		a = a[0:k] + a[i] + (a[i+1:n])[::-1] + a[k] + (a[k+1:i])[::-1]

#
# põhiprogrammi algus
#

sis = open('algesis.txt', 'rt')
val = open('algeval.txt', 'wt')

n = int(sis.readline().strip())
a = ''.join(sis.readline().strip().split())

leia_algarvud(min(10 ** n, 1000000))
assert(algarvud[-1] * algarvud[-1] > 10 ** n)

perm(a)

val.write('{0} {1}\n'.format(len(parim_plaan), parim_summa))
s = 0
a = ''
for (x, k) in parim_plaan:
	if k == 0:
		a = x + a
	if k == 1:
		a = a + x
	if algarv(a):
		s = s + summa(a)
	if algarv(a[::-1]):
		s = s + summa(a)
	val.write('{0} {1}\n'.format(a, s))
val.write('{0}\n'.format(parim_summa - s))
