#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cctype>

void done(double n, const char *s, ...) {
	fprintf(stdout, "%lf\n", n);
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(0);
}

bool isvoid(char c) {
	return c == 0 || isspace(c);
}

int cmp(const char *s1, const char *s2) {
	while (1) {
		while (isspace(*s1)) {
			++s1;
		}
		while (isspace(*s2)) {
			++s2;
		}
		while (1) {
			if (*s1 == 0 && *s2 == 0) {
				return 0;
			}
			if (isvoid(*s1) && isvoid(*s2)) {
				break;
			}
			if (tolower(*s1) < tolower(*s2)) {
				return -1;
			}
			if (tolower(*s1) > tolower(*s2)) {
				return +1;
			}
			++s1; ++s2;
		}
	}
}

double r = 0;
char v1[100], v2[100], v3[100];

int n, *a;
long long *b;

char h[100];
int hp, hs;
int hp1, hp2;
long long hss;

char s[100]; int u;
int vp, vs;
int vp1, vp2;
long long vss;

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: %s input hint output", argv[0]);
	}

	FILE *in = fopen(argv[1], "rt");
	if (!in) {
		done(0, "Can't open input file %s", argv[1]);
	}
	FILE *hint = fopen(argv[2], "rt");
	if (!hint) {
		done(0, "Can't open hint file %s", argv[2]);
	}
	FILE *out = fopen(argv[3], "rt");
	if (!out) {
		done(0, "Can't open output file %s", argv[3]);
	}

	if (fscanf(in, "%d", &n) != 1 || n < 1 || n > 1000000) {
		done(0, "Invalid input file (1)");
	}
	a = new int[n];
	b = new long long[n + 1];
	b[0] = 0;
	for (int i = 0; i < n; ++i) {
		int p, v;
		if (fscanf(in, "%d%d", &p, &v) != 2 || p < 0 || p > 100 || v < 0 || v > 1000000) {
			done(0, "Invalid input file (%d)", 2 + i);
		}
		a[i] = p - v;
		b[i + 1] = b[i] + a[i];
	}

	if (fgets(h, sizeof(h), hint) != h || cmp(h, "PLUSSIS") * cmp(h, "MIINUSES") * cmp(h, "NULLIS") != 0) {
		done(0, "Invalid hint file (1)");
	}
	if (fscanf(hint, "%d%d", &hp, &hs) != 2 || hp < 1 || hp > n || hs != a[hp - 1]) {
		done(0, "Invalid hint file (2)");
	}
	if (fscanf(hint, "%d%d%lld", &hp1, &hp2, &hss) != 3 || hp1 < 1 || hp1 > hp2 || hp2 < hp1 || hp2 > n || hss != b[hp2] - b[hp1 - 1]) {
		done(0, "Invalid hint file (3)");
	}

	if (fgets(s, sizeof(s), out) != s || cmp(s, "PLUSSIS") * cmp(s, "MIINUSES") * cmp(s, "NULLIS") * cmp(s, "EI TEA") != 0) {
		sprintf(v1, "Format error");
	} else if (cmp(s, "EI TEA") == 0) {
		sprintf(v1, "Not solved");
	} else if (cmp(s, h) != 0) {
		sprintf(v1, "Wrong answer");
	} else {
		r += 0.2;
		sprintf(v1, "OK");
	}

	if (fgets(s, sizeof(s), out) != s) {
		sprintf(v2, "Format error");
	} else if (sscanf(s, "%d%d%n", &vp, &vs, &u) != 2 || cmp(s + u, "") != 0) {
		sprintf(v2, "Format error");
	} else if (vp == 0 && vs == 0) {
		sprintf(v2, "Not solved");
	} else if (vp < 1 || vp > n || vs <= 0) {
		sprintf(v2, "Invalid value");
	} else if (vs != a[vp - 1] || vs < hs) {
		sprintf(v2, "Wrong answer");
	} else if (vs > hs) {
		done(0, "Wrong hint (2)");
	} else {
		r += 0.2;
		sprintf(v2, "OK");
	}

	if (fgets(s, sizeof(s), out) != s) {
		sprintf(v3, "Format error");
	} else if (sscanf(s, "%d%d%lld%n", &vp1, &vp2, &vss, &u) != 3 || cmp(s + u, "") != 0) {
		sprintf(v3, "Format error");
	} else if (vp1 == 0 && vp2 == 0 && vss == 0) {
		sprintf(v3, "Not solved");
	} else if (vp1 < 1 || vp1 > vp2 || vp2 < vp1 || vp2 > n || vss <= 0) {
		sprintf(v3, "Invalid value");
	} else if (vss != b[vp2] - b[vp1 - 1] || vss < hss) {
		sprintf(v3, "Wrong answer");
	} else if (vss > hss) {
		done(0, "Wrong hint (3)");
	} else {
		r += 0.6;
		sprintf(v3, "OK");
	}

	if (fscanf(out, "%10s", s) > 0) {
		done(0, "Extra data at end of output file");
	}

	done(r, "1) %s 2) %s 3) %s", v1, v2, v3);
}
