// 2016-11-19 programmeerimisvõistlus
// Ülesanne: VANAISA LOTOMÄNGUD (gümnaasiumi variant)
// Autor: Ahto Truu

// Natuke ebaefektiivne lahendus O(N^2) ajaga

#include <fstream>
#include <vector>
using namespace std;

ifstream sis("lotogsis.txt");
ofstream val("lotogval.txt");

int main() {
	int n;
	sis >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		int p, v;
		sis >> p >> v;
		// arvutame kohe välja päeva kaotuse
		a[i] = p - v;
	}

	// esimene alamülesanne: kogusumma
	long long s = 0;
	for (int i = 0; i < n; ++i) {
		s += a[i];
	}
	if (s < 0) {
		val << "PLUSSIS\n";
	}
	if (s == 0) {
		val << "NULLIS\n";
	}
	if (s > 0) {
		val << "MIINUSES\n";
	}

	// teine alamülesanne: suurima kaotuse päev
	int p = 0, m = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] > m) {
			p = i; m = a[i];
		}
	}
	val << p + 1 << " " << m << "\n";

	// kolmas alamülesanne: suurima kaotuse periood
	// arvutuse kiirendamiseks leiame kõigi prefiksite summad
	vector<long long> ss(n + 1);
	ss[0] = 0;
	for (int j = 0; j < n; ++j) {
		ss[j + 1] = ss[j] + a[j];
	}
	// nüüd vaatame läbi kõik võimalikud periood
	// aga iga perioodi summa arvutame tabelist vaatamisega
	// kokku kulub suurusjärgus N^2 operatsiooni
	int p1 = 0, p2 = 0, mm = 0;
	for (int i1 = 0; i1 < n; ++i1) {
		for (int i2 = i1; i2 < n; ++i2) {
			// leiame perioodi i1..i2 summa
			long long s = ss[i2 + 1] - ss[i1];
			if (s > mm) {
				p1 = i1; p2 = i2; mm = s;
			}
		}
	}
	val << p1 + 1 << " " << p2 + 1 << " " << mm << "\n";

	return 0;
}
